package gonganxitong

import (
	"fmt"
	"io"
	"strings"

	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/nfs"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type command struct {
	Table
	service service
	modify  string `name:"modify service_uid icon name index"`
}

func (s command) Modify(m *ice.Message, arg ...string) {
	uid := kit.Hashs(m.Option(model.SERVICE_UID), m.Option(model.INDEX))
	if s.Select(m.Spawn(), model.UID, uid).Length() == 0 {
		s.Insert(m, kit.Simple(model.UID, uid, m.OptionSimple(model.SERVICE_UID, model.INDEX))...)
	}
	s.Update(m, kit.Dict(arg), model.UID, uid)
	m.SetResult().Echo(uid)
}
func (s command) Autogen(m *ice.Message, arg ...string) {
	space := map[string][]string{}
	portal := map[string][]string{}
	s.List(m).Table(func(value ice.Maps) {
		if strings.HasSuffix(value[model.INDEX], ".allow") {
			space[value[model.SPACE]] = append(space[value[model.SPACE]], strings.ReplaceAll(value[model.INDEX], ".allow", ".portal"))
		}
		space[value[model.SPACE]] = append(space[value[model.SPACE]], value[model.INDEX])
		portal[value["portal"]] = append(portal[value["portal"]], value[model.INDEX])
	})
	for p, v := range space {
		nfs.Create(m.Message, "src/api/"+p+".go", func(w io.Writer) {
			fmt.Fprintf(w, "package api\n\n")
			for _, v := range v {
				fmt.Fprintf(w, "const %s = \"%s\"\n", strings.ToUpper(strings.ReplaceAll(strings.TrimPrefix(v, "web.team."), ".", "_")), v)
			}
		})
	}
	return
	nfs.Create(m.Message, "src/api/space.go", func(w io.Writer) {
		fmt.Fprintf(w, "package api\n\n")
		fmt.Fprintf(w, "var Space = map[string]string{\n")
		for p, v := range space {
			for _, v := range v {
				fmt.Fprintf(w, "\"%s\": \"%s\",\n", v, p)
			}
		}
		fmt.Fprintf(w, "}\n")
	})
	nfs.Create(m.Message, "src/api/portal.go", func(w io.Writer) {
		fmt.Fprintf(w, "package api\n\n")
		fmt.Fprintf(w, "var Portal = map[string]string{\n")
		for p, v := range portal {
			for _, v := range v {
				fmt.Fprintf(w, "\"%s\": \"%s\",\n", v, p)
			}
		}
		fmt.Fprintf(w, "}\n")
	})
}
func (s command) Cache(m *ice.Message, arg ...string) *ice.Message {
	kit.For(cmdPortal, func(k, v string) {
		m.Push(model.SPACE, cmdSpace[k])
		m.Push(model.PORTAL, v)
		m.Push(model.INDEX, k)
	})
	m.Sort("space,portal,index")
	return m
}
func (s command) List(m *ice.Message, arg ...string) *ice.Message {
	s.Tables(m, s.service).Fields(m,
		s.Key(s, model.UPDATED_AT), s.Key(s, model.INDEX),
		s.AS(s.Key(s.service, model.INDEX), "portal"),
		s.AS(model.NODENAME, model.SPACE),
	).Orders(m, "`space`,`index`").Limit(m, 300)
	s.Select(m).Action(s.Autogen, s.Cache)
	return m
}

var cmdPortal = map[string]string{}
var cmdSpace = map[string]string{}

func init() { ice.TeamCtxCmd(command{}) }
