package gonganxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type setting struct {
	Table
	service service
	recent  recent
	order   string `data:"102"`
	short   string `data:"name"`
	field   string `data:"name,type,help"`
	fields  string `data:"name,value"`
	create  string `name:"create name* type* help*" role:"tech"`
	update  string `name:"update" role:"void"`
}

func (s setting) Init(m *ice.Message, arg ...string) {
	s.Table.Init(m, arg...)
	s.Create(m, model.NAME, "profile", model.TYPE, "radio", "help", "将本系统展示到个人名片首页")
}
func (s setting) Create(m *ice.Message, arg ...string) {
	s.Hash.Create(m, arg...)
}
func (s setting) Update(m *ice.Message, arg ...string) {
	m.OptionDefault(model.PLACE_UID, m.Option(s.Keys(s.Place, model.UID)))
	if s.Table.Select(m.Spawn(), m.OptionSimple(model.PLACE_UID, model.USER_UID, model.NAME)...).Length() == 0 {
		s.Table.Insert(m, m.OptionSimple(model.PLACE_UID, model.USER_UID, model.NAME, model.VALUE)...)
	} else {
		s.Table.Update(m, kit.Dict(m.OptionSimple(model.VALUE)), m.OptionSimple(model.PLACE_UID, model.USER_UID, model.NAME)...)
	}
}
func (s setting) Profile(m *ice.Message, arg ...string) {
	s.Fields(m, s.Key(s, model.PLACE_UID))
	s.Select(m, s.Key(s, model.USER_UID), arg[0], s.Key(s, model.NAME), "profile", s.Key(s, model.VALUE), "on")
	return
	s.Tables(m, "LEFT JOIN recents ON args = settings.place_uid AND recents.user_uid = settings.user_uid AND recents.deleted_at IS NULL", s.service).Fields(m,
		model.SERVICE_ICON, model.SERVICE_NAME,
		s.Key(s.recent, model.CITY_NAME), s.Key(s.recent, model.STREET_NAME), s.Key(s.recent, model.PLACE_NAME),
		s.AS(model.NODENAME, model.SPACE), model.INDEX, s.Key(s, model.PLACE_UID),
	)
	s.Select(m, s.Key(s, model.USER_UID), arg[0], s.Key(s, model.NAME), "profile", s.Key(s, model.VALUE), "on")
}
func (s Table) SettingProfile(m *ice.Message, arg ...string) *ice.Message {
	return m.Cmdy(s.Prefix(m, setting{}), setting{}.Profile, arg)
}
func (s setting) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		data := ice.Maps{}
		msg := s.Select(m.Spawn(), s.Key(s, model.PLACE_UID), arg[0], s.Key(s, model.USER_UID), m.Option(model.USER_UID))
		msg.Table(func(value ice.Maps) { data[value[model.NAME]] = value[model.VALUE] })
		s.Hash.List(m).Table(func(value ice.Maps) { m.Push(model.VALUE, data[value[model.NAME]]) })
		m.Action()
	} else if len(arg) == 2 {
		s.SelectDetail(m, s.Key(s, model.PLACE_UID), arg[0], s.Key(s, model.USER_UID), m.Option(model.USER_UID), model.NAME, arg[1])
	}
	s.Display(m, "").DisplayCSS("")
}

func init() { ice.TeamCtxCmd(setting{Table: newTable()}) }
