package renzhengshouquan

import (
	"path"

	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/icebergs/base/nfs"

	"shylinux.com/x/community/src/renzhengshouquan/model"
)

type cert struct {
	Table
	order  string `data:"1"`
	fields string `data:"title,content,path,user_uid"`
	upload string `name:"upload" role:"leader"`
	remove string `name:"remove" role:"leader"`
}

func (s cert) Upload(m *ice.Message, arg ...string) {
	p := m.UploadSave(path.Join(nfs.USR, m.Option(mdb.FIELD), m.Option(model.AUTH_UID)) + nfs.PS)
	s.Create(m, model.PATH, p, model.AUTH_UID, m.Option(model.AUTH_UID))
}
func (s cert) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		s.Select(m, model.AUTH_UID, arg[0]).PushAction(s.Remove).Action(s.Upload).Display("").DisplayCSS("")
		s.Button(m, "", s.Upload)
	}
}

func init() { ice.TeamCtxCmd(cert{}) }
